autoduplex constraints should be dropped

Bug #487695 reported by Tim Waugh on 2009-11-24
108
This bug affects 20 people
Affects Status Importance Assigned to Milestone
Common Print Dialog
Wishlist
Unassigned
HPLIP
Undecided
Unassigned
hplip (Ubuntu)
Undecided
Unassigned
Maverick
Undecided
Unassigned
Natty
Undecided
Unassigned
system-config-printer (Ubuntu)
Undecided
Unassigned
Maverick
Undecided
Unassigned
Natty
Undecided
Unassigned

Bug Description

The "autoduplex" page sizes are a clever way of allowing the application to know in advance exactly where the page margins are when duplexing. However, it should not be an actual constraint on whether duplexing can be enabled.

The reason is that it can never be clear to the user why they cannot select a duplexing option. Their page size setting is correct (e.g. A4), and the installable options setting says that a duplexer is installed. There is no way to discover the "magic" page sizes.

Also there is no way for CUPS to know to set this magic page size as the default when adding a queue. It will look for "A4" or "Letter" depending on the locale.

Johannes Meixner (jsmeix) wrote :

When the user has selected the page size "A4",
all other page size entries in the PPD are
meaningless.

When the user has selected the page size "A4"
plus "duplex printing", the ImageableArea is still
those for "A4".

When the the ImageableArea for "A4" does not work
for "duplex printing", there must be matching
UIConstraints in the PPD to exclude both mutually.

Have a look at
https://bugs.launchpad.net/evince/+bug/428588/comments/22
and
https://bugs.launchpad.net/hplip/+bug/237342

On the one hand:
Whenever some kind of settings cannot work together,
appropriate UIConstraints must be specified in the PPD
so that the user's printing interface can show impossible
settings before a wrong or unexpected printout happens.

But on the other hand:
The defaults in a PPD must be so that all UIConstraints
are fulfilled so that by default printing "just works".

Tim Waugh (twaugh) wrote :

Here are some bugs and usability problems triggered by the current behaviour:

https://bugzilla.redhat.com/show_bug.cgi?id=540995
https://bugzilla.redhat.com/show_bug.cgi?id=538133

I favour Johannes' previous suggestion of having "A4" use the imageable area for duplex-enabled printing and "A4 Single-Sided" (or something) having the larger imageable area for when duplexing is not in use.

That way the "default" and obvious page size of A4 will allow duplexing.

Accepted hplip into maverick-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Changed in hplip (Ubuntu Maverick):
status: New → Fix Committed
tags: added: verification-needed
Changed in system-config-printer (Ubuntu Maverick):
status: New → Fix Committed
Martin Pitt (pitti) wrote :

Accepted system-config-printer into maverick-proposed, the package will build now and be available in a few hours. Please test and give feedback here. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you in advance!

Till Kamppeter (till-kamppeter) wrote :

The hplip package in -proposed has built now. Sorry for the delay, we had a problem with the package build.

Till Kamppeter (till-kamppeter) wrote :

Additional remark: The SRU for Ubuntu Maverick is not a fix for this bug but only a workaround. The HPLIP SRU switches print queues set up with hpcups to hpijs and the system-config-printer SRU makes new print queues set up with hpijs instead of hpcups. hpijs has no distinction of paper sizes for duples and single-sided.

The real fix would be to

- change the design of PPD files for hpcups so that it gets easier to turn on duplex printing. The standard page sizes ("A4") could have the duplex margins (which are the tightest ones). There could be alternative paper size settings as "A4 Extended Margins" and "A4 Borderless", both conflicting with duplex.

- make printing dialogs work better with conflicting options. All settings which do not conflict with the settings of the "Installable Options" group should be always shown and selectable. So if "double-sided long edge" conflicts with the paper size "A4", the options should be highlighted and the user warned, see the option setting parts of system-config-printer or xpp (from Universe). Hiding settings which conflict with other user-settable settings is very bad for usability. Also a very bad idea is to automatically change user settings without warning the user (like OOo does when it overrides the user setting "A4 Duplex" with the document setting "A4" and due to the conflict coming up then it switches also from double-sided to single-sided).

The quickest and easiest fix is to change the PPD design, but both fixes should get applied.

Till Kamppeter (till-kamppeter) wrote :

Lars, I am subscribing you to this bug as it should get fixed by the Common Printing Dialog

tags: added: cpd
Till Kamppeter (till-kamppeter) wrote :

See also bug 428588 and bug 657357 for more info about this problem.

Jean-Baptiste Lallement (jibel) wrote :

Could someone experiencing this problem test the package in maverick-proposed and report here ?
Thanks in advance.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package hplip - 3.10.6-1ubuntu10.1

---------------
hplip (3.10.6-1ubuntu10.1) maverick-proposed; urgency=low

  * debian/hplip-cups.postinst, debian/hpijs.postinst: Switch back to HPIJS as
    default driver (migrate hpcups queues to HPIJS) as there are still problems
    with hpcups and duplex printing (LP: #428588, LP: #487695, LP: #657357).
  * debian/control: Let hplip depend on hpijs instead of on hplip-cups as
    printer driver.
 -- Till Kamppeter <email address hidden> Thu, 21 Oct 2010 14:35:03 +0200

Changed in hplip (Ubuntu Maverick):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package system-config-printer - 1.2.3+20100723-0ubuntu8.1

---------------
system-config-printer (1.2.3+20100723-0ubuntu8.1) maverick-proposed; urgency=low

  * debian/patches/78_give-priority-to-hpijs.patch: Prioritize hpijs against
    hpcups again. With hpcups duplex printing does not work with most
    applications (LP: #428588, LP: #487695, LP: #657357).
 -- Till Kamppeter <email address hidden> Thu, 21 Oct 2010 14:58:06 +0200

Changed in system-config-printer (Ubuntu Maverick):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package hplip - 3.10.6-1ubuntu11

---------------
hplip (3.10.6-1ubuntu11) natty; urgency=low

  * debian/local/make-duplex-page-sizes-default.sh, debian/rules: Renamed
    paper sizes so that the duplex paper sizes (the ones with the tightest
    unprintable margins) get the standard ones and the former standard sizes
    get optional "Small Margins" sizes. This makes it possible to print
    duplex from current desktop applications like OpenOffice.org or GNOME
    applications (LP: #487695).
 -- Till Kamppeter <email address hidden> Wed, 10 Nov 2010 10:50:03 +0100

Changed in hplip (Ubuntu Natty):
status: New → Fix Released
Changed in system-config-printer (Ubuntu Natty):
status: New → Invalid

After installing the new HPLIP package in Natty, please check with system-config-printer (System -> Administration -> Printing) whether the default settings are correct, especially for Media Size and Double-Sided Printing. Use the standard page sizes (not "Small Margins" or "Borderless" to allow duplex printing.

Lars, see comment #6, second suggestion.

Changed in common-print-dialog-gtk:
importance: Undecided → Wishlist
Olivier Berger (oberger) wrote :

I think the change introduced by Till Kamppeter (make-duplex-page-sizes-default.sh) now has side effects on the regular (not duplex), at least for A4, where normal margins aren't used, and always set to the duplex ones.

See Debian bug http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=655106 for more details.

I'd suggest improving the solution, or getting rid completely of this make-duplex-page-sizes-default.sh if upstream is now working properly.

Thanks for caring.

Pete (9-pete) wrote :

I have problems with lost margins printing to a new OfficeJet 6700 using HPLIP version 3.14.1. Printing the test page on A4 paper during installation of 3.14.1 gave correct results. After installation, I changed the paper size from letter back to A4 and printed a test page. The ruler at the bottom is missing (see bug 1276801 for details and a scanned pdf of the output).

There seem to be multiple reports of similar issues. Should these be collected somewhere?

Pete (9-pete) wrote :

I have now installed HPLIP 3.14.3. This has solved most of my problems (see bug https://bugs.launchpad.net/bugs/1276801), and my printer now behaves as described in this bug.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Related blueprints

Remote bug watches

Bug watches keep track of this bug in other bug trackers.